.model small
.stack 100h

.data
 
    ;duom1     db 'c:\duom1.txt',0
    ;duom2     db 'c:\duom2.txt',0   
    ;rez       db 'c:\rez.txt',0  
    
    duom1     db 100 dup (0)
    duom2     db 100 dup (0)
    rez       db 100 dup (0)  
    klaida1   db 'Nepavyko atidaryti failo$'
    klaida2   db 'Nepavyko nuskaityt failo$' 
    klaida3   db 'Ne visi parametrai ivesti. Help: ?/$'   
    klaida4   db 'Neteisingi duomenys duomenu failuose$'
    handle1   dw ? ; pirmo failo                         
    handle2   dw ? ; antro failo           
    handle3   dw ? ; rez failo
    buffer1   db 100 dup (?) ; saugot duomenim   
    buffer2   db 100 dup (?) ; saugot duomenim 
    buffer3   db 100 dup (?)                            
    zinute    db '========================================================',13,10
              db '',13,10
              db '',13,10
              db 'Programa atlieka XOR operacija su dviem beveik bet kokio',13,10
              db 'ilgio dvejetainiais skaiciais.',13,10
              db 'Pradiniai skaiciai ir rezultatas failuose',13,10
              db 13,10
              db 'naudojimas: antra duom1.txt duom2.txt',13,10
              db '========================================================$'    
    
.code


    mov ax,@data
    mov ds,ax 
    
    mov bx,81h 			;programos paleidimo parametrai rasomi segmente es pradedant 129 (arba 81h) baitu
    xor si,si
    xor di,di

;ar buvo ivesta /?    
ciklas:
    mov ax,es:[bx] 		; i ax isirasom du baitus, i kuriuos rodo registras bx
    cmp al,0Dh	    		;tikrinam, ar tai ne pabaigos simbolis
    je pradzia			;je - jeigu 1 operandas lygu 2
    cmp ax,"?/"
    je radom

;nuskaito pirma parametra    
duomen1:

    mov ax,es:[bx]
    cmp al,' '
    je duomen2
    cmp al,0Dh
    je pradzia
    mov [duom1+si],al  
    inc si  

    inc bx  
    
  
    jmp duomen1

;nuskaito antra parametra    
duomen2:   
    
    inc bx
    cmp bx, 82h
    je ciklas
    mov ax, es:[bx]
    cmp al,0Dh
    je pradzia 
    cmp al,' '
    je isvalyt
    mov [duom2+di],al
    inc di   

    jmp duomen2     


isvalyt:
    xor di,di
    jmp rezult
    
rezult:
    
    inc bx    
    mov ax, es:[bx]
    cmp al,0Dh
    je pradzia    
    mov [rez+di],al
    inc di   

    jmp rezult        
;jeigu buvo ivesta /?
radom:

    mov ah,09h
    mov dx,offset zinute
    int 21h 
    
    mov ah,4Ch
    int 21h    
   
     
    
;klaidos
param_klaida:

    lea dx,klaida3
    mov ah,09h
    int 21h 
    
    mov ah,4Ch
    int 21h


    
atidarymo_klaida:  

    lea dx,klaida1    
    mov ah,09h
    int 21h  
    
    mov ah,4Ch
    int 21h
    
nuskaitymo_klaida: 

    lea dx,klaida2    
    mov ah,09h
    int 21h  
    
    mov ah,4Ch
    int 21h


;pirmas F1.txt   

pradzia:   
 
;ar buvo ivesti visi parametrai
    cmp duom1,0
    je param_klaida
    cmp duom2,0
    je param_klaida 
    cmp rez,0
    je param_klaida    
;atidarom faila   
    mov dx,offset duom1     
    mov al,0       ; 0 - read-only    
    mov ah,3Dh ; failo atidarymo f-ja
    int 21h    
    mov handle1,ax   ; issaugom failo adresa
    
    jc atidarymo_klaida		;jc-Short Jump if Carry flag is set to 1., if cf=1 then jump
    
    
;kopijuojam failo turini i bufferi
    
    mov dx,offset buffer1 ; kopijuojam bufferio adresa
    mov bx,handle1
    mov cx,100    ; kiek baitu (simboliu) skaitysim
    mov ah,3Fh  ; failo skaitymo f-ja
    int 21h  
    
    jc nuskaitymo_klaida
    
;uzdarom faila

    mov bx,handle1
    mov ah,3Eh ; failo uzdarymo f-ja
    int 21h 
                      

;antras F2.txt 

;atidarom faila
        
    mov ax,@data
    mov ds,ax    
    mov dx,offset duom2     
    mov al,0       ; 0 - read-only    
    mov ah,3Dh ; failo atidarymo f-ja
    int 21h    
    mov handle2,ax   ; issaugom failo adresa    
    jc atidarymo_klaida
    
    
;kopijuojam failo turini i buffer
    
    mov dx,offset buffer2 ; kopijuojam bufferio adresa
    mov bx,handle2
    mov cx,100    ; kiek baitu (simboliu) skaitysim
    mov ah,3Fh  ; failo skaitymo f-ja
    int 21h  
    
    jc nuskaitymo_klaida
    
;uzdarom faila

    mov bx,handle2
    mov ah,3Eh ; failo uzdarymo f-ja
    int 21h  
    
    xor si,si
    xor di,di
    jmp ciklas1
     
;========================================================  

duom_klaida: 

    lea dx,klaida4    
    mov ah,09h
    int 21h  
    
    mov ah,4Ch
    int 21h

tikrinimas1:
    inc si
    jmp ciklas1
    
tikrinimas2:
    inc di 
    jmp ciklas2
   

ciklas1: 
        
    cmp [buffer1 + si],'$' 
    je  ciklas2 
    cmp [buffer1 + si],'0'
    je tikrinimas1
    cmp [buffer1 + si],'1' 
    je tikrinimas1

    jmp duom_klaida 

ciklas2:  
    
    cmp [buffer2 + di],'$' 
    je  sidi 
    cmp [buffer2 + di],'0'
    je tikrinimas2
    cmp [buffer2 + di],'1' 
    je tikrinimas2
          
    jmp duom_klaida
    
sidi:
    push si
    push di 
    cmp si,di 
    ja pirmas_ilgesnis
    jb antras_ilgesnis
    
pirmas_ilgesnis: 
    mov bh,[buffer1+si]
    mov [buffer3+si],bh 
    cmp si,0 
    je isimam_sidi   
    dec si 
    jmp pirmas_ilgesnis
    
antras_ilgesnis:
    mov bh,[buffer2+di]
    mov [buffer3+di],bh
    cmp di,0
    je isimam_sidi
    dec di
    jmp antras_ilgesnis

isimam_sidi:

    pop di			;pop ima 16 bitu reiksme is steko
    pop si

ciklas3:   
     
    cmp si,0
    je  exit
    cmp di,0
    je  exit
    mov bh,[buffer1+si-1]    
    cmp bh, [buffer2+di-1]    
    je  lyginimas1
    jne lyginimas2
    
lyginimas1:
    cmp si,di
    jae apnulint1		;Short Jump if first operand is Above or Equal to second operand (as set by CMP instruction). if cf=0 then jump
    jb  apnulint2   		;Short Jump if first operand is Below second operand (as set by CMP instruction), if cf=1 then jump
    
         
lyginimas2:
    cmp si,di
    jae vienas1
    jb  vienas2

apnulint1:
    mov [buffer3 + si-1],'0'
    dec si
    dec di    
    jmp ciklas3

vienas1:
    mov [buffer3 + si-1],'1'
    dec si
    dec di    
    jmp ciklas3    
    
apnulint2:
    mov [buffer3 + di-1],'0'
    dec si
    dec di    
    jmp ciklas3

vienas2:
    mov [buffer3 + di-1],'1'
    dec si
    dec di    
    jmp ciklas3
    
exit:    
;baigiam programa 
;    pop si
;    mov [buffer3 + si],'$' 

    lea dx,buffer3
    mov ah,09h
    int 21h
    
    call irasymas 
   
       
    mov ah,4Ch
    int 21h 

irasymas:

;failo sukurimas
    
    mov dx,offset rez
    xor cx,cx
    mov ah,3Ch
    int 21h
;failo atidarymas

    mov dx,offset rez
    mov al,2
    mov ah,3Dh
    int 21h      
    
    mov handle3,ax
    
;rasymas i faila
    
    mov dx,offset buffer3
    mov bx,handle3
    mov cx,100 ; rasysim 100 baitus i faila
    mov ah,40h
    int 21h 
    
;failo uzdarymas
    
    mov bx,handle3
    mov ah,3Eh
    int 21h   
    
RET



END